;;;*THIS PARAMETRIC ROUTINE DRAWS WINDOWS
;;;*Written by K. Ramage February 1995.
;;;*--------------------------------------------------------
(defun C:hole ( / IP THK ANG L P1 P2 P3 P4 P5 P6 P7 P8 P9
                    P10 P11 P12 P13 P14 P15 P16 P17 P18 P19) 
                    (setq doc (vla-get-activedocument (vlax-get-acad-object)))
  (vla-startundomark doc)
;;;*----------------------------------------------------------
;;;*INITIALISE
        (initerr)
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
        (setvar "OSMODE" OLDSNAP)
;;;*----------------------------------------------------------
     (initget 1)
     (setq IP (getpoint "\nInsertion Point : ")
          P11 (getpoint IP "\nWall Thickness : ")
     );setq
     (setvar "OSMODE" 642)
     ;(setvar "PICKBOX" 0)
     (setq ANG (angle IP P11)
           ANG (RTD ANG)
           ANG (+ ANG 90.0)
           THK (distance IP P11)
             L (getreal "\nLength of Window : ")
           P1 (polar IP (DTR (+ ANG 180.0)) (/ L 2))
           P2 (polar P1 (DTR (+ ANG 270.0)) (+ THK 0.0))
           P3 (polar P2 (DTR ANG) L)
           P4 (polar P3 (DTR (+ ANG 90.0)) (+ THK 0.0))
           P5 (polar P1 (DTR (+ ANG 270.0)) (/ THK 2))
           P6 (polar P5 (DTR (+ ANG 90.0)) 25.0)
           P7 (polar P6 (DTR (+ ANG 270.0)) 50.0)
           P8 (polar P5 (DTR ANG) L)
           P9 (polar P6 (DTR ANG) L)
          P10 (polar P7 (DTR ANG) L)
          P12 (polar P11 (DTR (+ ANG 180.0)) (/ L 2))
          P13 (polar P11 (DTR ANG) (/ L 2))
          P14 (polar P11 (DTR ANG) 100.0)
          P15 (polar IP (DTR (+ ANG 180.0)) (/ L 2))
          P16 (polar IP (DTR ANG) (/ L 2))
          P17 (polar IP (DTR ANG) 100.0)

    );setq

      (command "_line" P1 P2 "")
	(setq P18 (entlast))
    
      (command "_line" P4 P3 "")
	(setq P19 (entlast))
    
     (command "_TRIM" P18 P19 "" IP P11 "")

;;;*RESET ENVIROMENT
   (reset)
    (vla-endundomark doc)
   (princ)
);defun C:WINT
;;;*==========================================================
(defun initerr ()
  (setq oldlayer (getvar "clayer"))
  (setq oldsnap (getvar "osmode"))
  (setq oldpick (getvar "pickbox"))
  (setq temperr *error*)
  (setq *error* trap)
  (princ)
)					;defun
;;;*===========================================================
(defun trap (errmsg)
  (command nil nil nil)
  (if (not (member errmsg '("console _.BREAK" "Function Cancelled"))
      )
    (princ (strcat "\nError: " errmsg))
  )					;                 
  (setvar "clayer" oldlayer)
  (setvar "BLIPMODE" 0)
  (setvar "menuecho" 0)
  (setvar "highlight" 1)
  (setvar "osmode" oldsnap)
  ;(setvar "pickbox" oldpick)
  (princ "\nError Resetting Enviroment ")
  (terpri)
  (setq *error* temperr)
  (princ)
)					;defun
;;;*===========================================================
(defun reset ()
  (setq *error* temperr)
  (setvar "clayer" oldlayer)
  (setvar "BLIPMODE" 0)
  (setvar "menuecho" 0)
  (setvar "highlight" 1)
  (setvar "osmode" oldsnap)
  ;(setvar "pickbox" oldpick)

  (princ)
)					;defun
;;;*======================================================
;*-----------------------------------------------------------------------------
;*dtr converts degrees to radians
(defun dtr (a)
 (* pi (/ a 180))
);defun
;*-----------------------------------------------------------------------------
;*rtd converts radians to degrees
(defun rtd (a)
 (/ (* a 180) pi)
);defun
;*-----------------------------------------------------------------------------
(princ)
               





(defun C:hole900 ( / IP THK ANG L P1 P2 P3 P4 P5 P6 P7 P8 P9
                    P10 P11 P12 P13 P14 P15 P16 P17 P18 P19)


;;;*----------------------------------------------------------
;;;*INITIALISE
(setq doc (vla-get-activedocument (vlax-get-acad-object)))
(vla-startundomark doc)             ;      _.U
        (initerr)
;        (setvar "BLIPMODE" 0)
;        (setvar "OSMODE" OLDSNAP)
;;;*----------------------------------------------------------
     (initget 1)
     (setq IP (getpoint "\nInsertion Point : ")
          P11 (getpoint IP "\nWall Thickness : ")
     );setq
     (setvar "OSMODE" 642)
     (setq ANG (angle IP P11)
           ANG (RTD ANG)
           ANG (+ ANG 90.0)
           THK (distance IP P11)
 ;            L (getreal "\nLength of Window : ")
            L 900
           P1 (polar IP (DTR (+ ANG 180.0)) (/ L 2))
           P2 (polar P1 (DTR (+ ANG 270.0)) (+ THK 0.0))
           P3 (polar P2 (DTR ANG) L)
           P4 (polar P3 (DTR (+ ANG 90.0)) (+ THK 0.0))
           P5 (polar P1 (DTR (+ ANG 270.0)) (/ THK 2))
           P6 (polar P5 (DTR (+ ANG 90.0)) 25.0)
           P7 (polar P6 (DTR (+ ANG 270.0)) 50.0)
           P8 (polar P5 (DTR ANG) L)
           P9 (polar P6 (DTR ANG) L)
          P10 (polar P7 (DTR ANG) L)
          P12 (polar P11 (DTR (+ ANG 180.0)) (/ L 2))
          P13 (polar P11 (DTR ANG) (/ L 2))
          P14 (polar P11 (DTR ANG) 100.0)
          P15 (polar IP (DTR (+ ANG 180.0)) (/ L 2))
          P16 (polar IP (DTR ANG) (/ L 2))
          P17 (polar IP (DTR ANG) 100.0)

    );setq
  

      (command "_line" P1 P2 "")
	(setq P18 (entlast))
    
      (command "_line" P4 P3 "")
	(setq P19 (entlast))
    
     (command "_TRIM" P18 P19 "" IP P11 "")
(vla-endundomark doc)               ;   UNDO

  
;;;*RESET ENVIROMENT
   (reset)
   (princ)
);defun C:WINT
;;;*==========================================================
(defun initerr ()
  (setq oldlayer (getvar "clayer"))
  (setq oldsnap (getvar "osmode"))
  (setq oldpick (getvar "pickbox"))
  (setq temperr *error*)
  (setq *error* trap)
  (princ)
)					;defun
;;;*===========================================================
(defun trap (errmsg)
  (command nil nil nil)
  (if (not (member errmsg '("console _.BREAK" "Function Cancelled"))
      )
    (princ (strcat "\nError: " errmsg))
  )					;                 
  (setvar "clayer" oldlayer)
  (setvar "BLIPMODE" 0)
  (setvar "menuecho" 0)
  (setvar "highlight" 1)
  (setvar "osmode" oldsnap)
  ;(setvar "pickbox" oldpick)
  (princ "\nError Resetting Enviroment ")
  (terpri)
  (setq *error* temperr)
  (princ)
)					;defun
;;;*===========================================================
(defun reset ()
  (setq *error* temperr)
  (setvar "clayer" oldlayer)
  (setvar "BLIPMODE" 0)
  (setvar "menuecho" 0)
  (setvar "highlight" 1)
  (setvar "osmode" oldsnap)
  ;(setvar "pickbox" oldpick)
  (princ)
)					;defun
;;;*======================================================
;*-----------------------------------------------------------------------------
;*dtr converts degrees to radians
(defun dtr (a)
 (* pi (/ a 180))
);defun
;*-----------------------------------------------------------------------------
;*rtd converts radians to degrees
(defun rtd (a)
 (/ (* a 180) pi)
);defun
;*-----------------------------------------------------------------------------
(princ)



(defun C:hole1600 ( / IP THK ANG L P1 P2 P3 P4 P5 P6 P7 P8 P9
                    P10 P11 P12 P13 P14 P15 P16 P17 P18 P19) 
;;;*----------------------------------------------------------
;;;*INITIALISE
(setq doc (vla-get-activedocument (vlax-get-acad-object)))
 (vla-startundomark doc)             ;      _.U
       (initerr)
        (setvar "CMDECHO" 0)
        (setvar "BLIPMODE" 0)
        (setvar "OSMODE" OLDSNAP)
;;;*----------------------------------------------------------
     (initget 1)
     (setq IP (getpoint "\nInsertion Point : ")
          P11 (getpoint IP "\nWall Thickness : ")
     );setq
     (setvar "OSMODE" 642)
     ;(setvar "PICKBOX" 0)
     (setq ANG (angle IP P11)
           ANG (RTD ANG)
           ANG (+ ANG 90.0)
           THK (distance IP P11)
 ;            L (getreal "\nLength of Window : ")
            L 1600
           P1 (polar IP (DTR (+ ANG 180.0)) (/ L 2))
           P2 (polar P1 (DTR (+ ANG 270.0)) (+ THK 0.0))
           P3 (polar P2 (DTR ANG) L)
           P4 (polar P3 (DTR (+ ANG 90.0)) (+ THK 0.0))
           P5 (polar P1 (DTR (+ ANG 270.0)) (/ THK 2))
           P6 (polar P5 (DTR (+ ANG 90.0)) 25.0)
           P7 (polar P6 (DTR (+ ANG 270.0)) 50.0)
           P8 (polar P5 (DTR ANG) L)
           P9 (polar P6 (DTR ANG) L)
          P10 (polar P7 (DTR ANG) L)
          P12 (polar P11 (DTR (+ ANG 180.0)) (/ L 2))
          P13 (polar P11 (DTR ANG) (/ L 2))
          P14 (polar P11 (DTR ANG) 100.0)
          P15 (polar IP (DTR (+ ANG 180.0)) (/ L 2))
          P16 (polar IP (DTR ANG) (/ L 2))
          P17 (polar IP (DTR ANG) 100.0)

    );setq
      (command "_line" P1 P2 "")
	(setq P18 (entlast))
    
      (command "_line" P4 P3 "")
	(setq P19 (entlast))
    
     (command "_TRIM" P18 P19 "" IP P11 "")
(vla-endundomark doc)
;;;*RESET ENVIROMENT
   (reset)
   (princ)
);defun C:WINT
;;;*==========================================================
(defun initerr ()
  (setq oldlayer (getvar "clayer"))
  (setq oldsnap (getvar "osmode"))
  (setq oldpick (getvar "pickbox"))
  (setq temperr *error*)
  (setq *error* trap)
  (princ)
)					;defun
;;;*===========================================================
(defun trap (errmsg)
  (command nil nil nil)
  (if (not (member errmsg '("console _.BREAK" "Function Cancelled"))
      )
    (princ (strcat "\nError: " errmsg))
  )					;                 
  (setvar "clayer" oldlayer)
  (setvar "BLIPMODE" 0)
  (setvar "menuecho" 0)
  (setvar "highlight" 1)
  (setvar "osmode" oldsnap)
  ;(setvar "pickbox" oldpick)
  (princ "\nError Resetting Enviroment ")
  (terpri)
  (setq *error* temperr)
  (princ)
)					;defun
;;;*===========================================================
(defun reset ()
  (setq *error* temperr)
  (setvar "clayer" oldlayer)
  (setvar "BLIPMODE" 0)
  (setvar "menuecho" 0)
  (setvar "highlight" 1)
  (setvar "osmode" oldsnap)
  ;(setvar "pickbox" oldpick)
  (princ)
)					;defun
;;;*======================================================
;*-----------------------------------------------------------------------------
;*dtr converts degrees to radians
(defun dtr (a)
 (* pi (/ a 180))
);defun
;*-----------------------------------------------------------------------------
;*rtd converts radians to degrees
(defun rtd (a)
 (/ (* a 180) pi)
);defun
;*-----------------------------------------------------------------------------
(princ)


